#ifndef HOTLIB

#define HOTLIB

/* hotkey item header */

typedef struct  
{
    short   id;
    short   type;
    void    *sbfp;
    short   len;
} HK_HEAD, *PHK_HEAD;

typedef struct
{
    HK_HEAD hd;
    char name[1];
} HK_ITEM, *PHK_ITEM;


#define HK_ID   0x6869

#define HKI_LLRC    -8
#define HKI_STPR    -6
#define HKI_STBF    -4
#define HKI_STUF    -2
#define HKI_CMD      0
#define HKI_NOP      2
#define HKI_XTHG     4
#define HKI_XFIL     6
#define HKI_PICK     8
#define HKI_WAKE    10
#define HKI_WKXF    12

#define HKI__TRN     0
#define HKI_TRN      1

typedef struct
{
    short   jsrl;
    long    gard;
    short   xo;
    short   yo;
    short   xs;
    short   ys;
    short   brdr;
    short   gmem;
    short   jma6;
    } HKH_GUARD, *PHKH_GUARD;

#define HKH_JSRL        0x4eb9
#define HKH_JMPA6       0x4ed6

int hk_set (int key, PHK_ITEM item, PHKH_GUARD guard);
int hk_reset (int newkey, char * oldkey_name);
int hk_on (char * key_name);
int hk_off (char * key_name);
int hk_fitem (char *key_name, PHK_ITEM *pItem, short *key, short *number); 
int hk_remv (char * key_name);
int hk_sstbf (char *string);
int hk_getbf (int flag, char **pString);
int hk_cjob (void);
int hk_kjob (void);
int hk_do(PHK_ITEM pItem);

void * malloc0 (int size);

#endif
