*
* Thing.s 
* 
* A public domain implementation of the Thing system for c68
* Part of the HOTStuff library
*
* (c) Jonathan Hudson 1993
*

sms.lthg        equ     $26             ; Link in THinG
sms.rthg        equ     $27             ; Remove THinG
sms.uthg        equ     $28             ; Use THinG
sms.fthg        equ     $29             ; Free THinG
sms.zthg        equ     $2a             ; Zap THinG
sms.nthg        equ     $2b             ; Next THinG
sms.nthu        equ     $2c             ; Next Thing User

sms.rchp        equ     $19
 
err.nimp 	equ    	-19
err.ipar	equ	-15

th_name		equ	$2a

.globl	sms_lthg
.globl	sms_rthg
.globl	sms_uthg
.globl	sms_fthg
.globl	sms_zthg
.globl	sms_nthg
.globl	sms_nthu
.globl  thg_free

.text
*
* d0 = sms_lthg (PTHG_LINK linkage);
*
sms_lthg:
	link	a6,#0               	; frame pointer
	movem.l	d2-d4/a2-a5,-(sp)       ; save regs
	jsr     getthg	            	; get thing vector
	bne	thg_done                ; Oh dear
	move.l	a0,a5			; vector
	move.l	8(a6),a1                ; linkage              
	moveq	#sms.lthg,d0            ; action
	jsr	(a5)                    ; jump to it
	bra	thg_done                ; OK

*
*   d0 = sms_fthg(char *name, int jobId, int data1, int *data2,
*                       void *addr1, void **addr2);
*
*   in  d2 = data1;         out *data2 = d2
*       d3 = *data2;
*       a1 = addr1;
*       a2 = *addr2;            *addr2 = a2
*

sms_fthg:
	link	a6,#0               	; frame pointer
	movem.l	d2-d4/a2-a5,-(sp)       ; save 'em
	jsr	getthg               	; get vector
	bne	thg_done                ; ow shucks
	move.l	a0,a5
	move.l	8(a6),a1                ; C string
	jsr	__StackA1               ;  to QDOS string
	move.l	a1,a0                   ; goes here
	move.l	12(a6),d1               ; d1 - user job id
	move.l	16(a6),d2               ; d2 - parameter
	move.l	20(a6),a3               ; address of next data
        cmp.l   #0,a3                   ; given ?
        beq     l10                     ; ignore if NULL
	move.l	(a3),d3                 ; got it
l10:
	move.l	24(a6),a1               ; address parameter
	move.l	28(a6),a4               ; address **
        cmp.l   #0,a4                   ; given
        beq     l11                     ; ignore if NULL
	move.l	(a4),a2                 ; got it
l11:
	moveq	#sms.fthg,d0            ; action
	jsr	(a5)                    ; do it
	tst.l	d0                      ; what happened ?
	bne	thg_rare                ; error
        cmp.l   #0,a3                   ; got a return value
        beq     l12                     ; no, skip
	move.l	d2,(a3)                 ; return d2
l12:
        cmp.l   #0,a4                   ; and this one ?
        beq     l13                     ; no, so skip it
	move.l	a2,(a4)                 ; or return it
l13:
	bra	thg_done                ; done

*
*   d0 = sms_uthg(char *name, int timeout, int jobId, int *data1,
*                    void **addr1, int *version, void **);
*

sms_uthg:
	link	a6,#0               	; frame pointer
	movem.l	d2-d4/a2-a5,-(sp)       ; save 'em
	jsr	getthg               	; vector
	bne	thg_done                ; no
	move.l	a0,a5
	move.l	8(a6),a1                ; C string
	jsr	__StackA1               ; to QDOS
	move.l	a1,a0                   ; and here
	move.l	12(a6),d3               ; timeout
	move.l	16(a6),d1               ; job id
	move.l	20(a6),a3               ; data address
        cmp.l   #0,a3                   ; no
        beq     l1                      ; skip it
	move.l	(a3),d2                 ; or got it
l1:
	move.l	24(a6),a4               ; address address
        cmp.l   #0,a4                   ; got it ?
        beq     l2                      ; no (maybe this should be an error
                                        ; as we can't now return the THING
                                        ; address, but it's in the linkage, OK
	move.l	(a4),a2                 ; OK
l2:
	moveq	#sms.uthg,d0            ; action
	jsr	(a5)                    ; jump to it
	tst.l	d0                      ; OK ?
	bne	thg_rare                ; no
        cmp.l   #0,a3                   ; return for parameter
        beq     l3                      ; no...
	move.l	d2,(a3)                 ; return it
l3:
        cmp.l   #0,a4                   ; address for THING ???
        beq     l4                      ; no, skip
	move.l	a2,(a4)                 ; yes, here it is
l4:
	move.l	28(a6),a3               ; address of version
        cmp.l   #0,a3                   ; might not care
        beq     l5                      ; so what ?
	move.l	d3,(a3)                 ; return it
l5:
	move.l	32(a6),a3               ; address for thing
        cmp.l   #0,a3                   ; some people are really dumb !!
        beq     thg_done                ; should be an error ?
	move.l	a1,(a3)                 ; return linkage
	bra	thg_done                ; and done
*
*   d0 = sms_rthg (char *name)
*   d0 = sms_zthg (char *name)
*
sms_rthg:
	link	a6,#0               	; frame pointer
	movem.l	d2-d4/a2-a5,-(sp)       ; saved
	moveq	#sms.rthg,d4            ; remove thing
        bra     xthing                  ; do it
sms_zthg:
	link	a6,#0               	; frame pointer
	movem.l	d2-d4/a2-a5,-(sp)       ; got the idea yet ?
	moveq	#sms.zthg,d4            ; zap
xthing:
	jsr	getthg               ; get vector
	bne	thg_done                ; oh bugger
	move.l	a0,a5
	move.l	8(a6),a1                ; name
	jsr	__StackA1               ; make QDOS 
	move.l	a1,a0                   ; goes here
	move.l  d4,d0                   ; do this
	jsr	(a5)                    ;   now ..
		
thg_done:	
	tst.l	d0
*
*       If we're not well done, then we must be rare ???
*

thg_rare:
        movem.l	(sp)+,d2-d4/a2-a5
	unlk	a6
	rts

*
*   d0 = sms_nthg (char *name, PTHG_LINK * linkage);
*
sms_nthg:
	link	a6,#0               	; frame pointer
	movem.l	d2-d4/a2-a5,-(sp)       ; save em
	jsr	getthg               	; vector
	bne	thg_done                ; no
	move.l	a0,a5
	move.l	12(a6),a3               ; return address
	move.l	8(a6),a1                ; thing name
        cmp.l   #0,a1                   ; is it zero
        beq     l22                     ; yes, so go from  start
	cmp.l	#0,a3                   ; got a return address ?
	beq	par_err                 ; no, bomb out
	move.l	(a3),a1                 ; return address
	cmp.l	#0,a1                   ; is this NULL
	bne	l21                     ; no, use given name
	jsr	__StackA1               ; C -> QDOS
        bra     l22                 
l21:
	lea.l	th_name(a1),a0	        ; last name
	bra	l23                 
l22:	move.l	a1,a0                   ; using name           
l23:
	moveq   #sms.nthg,d0            ; get thing
	jsr	(a5)                    ; it
        tst.l   d0                      ; the a1 value ain't quite as advertised
        beq     l24                     ; OK
        move.l  #0,a1                   ; as documented
l24:
	move.l	a1,(a3)                 ; always return linkage
	bra	thg_done                ; done
par_err:
	moveq	#err.ipar,d0            ; bad parameters
	bra	thg_done                ; done

*
*   d0 = sms_nthu (char *name, PTHG_LINK * linkage, int *jobid);
*
sms_nthu:
	link	a6,#0               	; frame pointer
	movem.l	d2-d4/a2-a5,-(sp)       ; save
	jsr	getthg	        	; vector
	bne	thg_done                ; no
	move.l	a0,a5
	move.l	12(a6),a3               ; return address
        cmp.l   #0,a3                   ; no
        beq     par_err                 ; dumbo
	move.l	16(a6),a4               ; job id address
        cmp.l   #0,a4                   ; just as silly (almost)
        beq     par_err                 ; show so
	move.l	8(a6),a1                ; thing name
        cmp.l   #0,a1                   ; is it zero
        beq     par_err                 ; yes, oh dear
	jsr	__StackA1               ; C -> QDOS
	move.l	a1,a0                   ; here
	move.l	(a3),a1                 ; linkage
	moveq   #sms.nthu,d0            ; action
	jsr	(a5)                    ; do it
	move.l	a1,(a3)                 ; next linkage
	move.l	d2,(a4)                 ; job id
	bra	thg_done                ; at last
*
*   free0(void *addr);
*
thg_free:
        move.l  4(sp),a0
        movem.l d2-d3/a2-a3,-(sp)
        moveq   #sms.rchp,d0
        trap    #1
        movem.l (sp)+,d2-d3/a2-a3
        rts
	end
